/* ic.c */
#include "mpi.h"

main( argc, argv )
     int argc;
     char **argv;
{
  int rank, key, his_key;
  MPI_Comm myComm, myComm2;
  MPI_Comm myFirstComm;
  MPI_Comm mySecondComm;
  int i;
  MPI_Status status;
  
  /* Initialization */
  MPI_Init ( &argc, &argv );
  MPI_Comm_rank ( MPI_COMM_WORLD, &rank);
  
  /* Generate membership key in the range [0,1] */
  key = rank % 2;
  
  /* Build intra-communcator for local sub-group */
  MPI_Comm_split ( MPI_COMM_WORLD, key, rank, &myComm );
  
  /* Build inter-communicators */
  if (key == 0) {
	MPI_Intercomm_create ( myComm, 0, MPI_COMM_WORLD, 1, 1, 
						  &myFirstComm );
        printf("I made it here!\n");
	MPI_Comm_dup ( myFirstComm, &mySecondComm );
        printf("I made it after 'here'!\n");
	if (mySecondComm->send_context != mySecondComm->recv_context)
	  printf("Error in MPI_Comm_dup of inter-communicators\n");
 	if (rank == 0) {
	  his_key = -1;
	  printf("[%d] Before swap  key = %d, his_key = %d\n", rank,
			 key, his_key);
	  MPI_Sendrecv (&key,     1, MPI_INT, 0, 2,
					&his_key, 1, MPI_INT, 0, 2,	
					mySecondComm, &status);
	  printf("[%d] After swap  key = %d, his_key = %d\n", rank,
			 key, his_key);
	}
  }
  else if (key == 1) {
	MPI_Intercomm_create ( myComm, 0, MPI_COMM_WORLD, 0, 1,
						  &myFirstComm );
        printf("I made it here!\n");
	MPI_Comm_dup ( myFirstComm, &mySecondComm );
        printf("I made it after 'here'!\n");
	if (mySecondComm->send_context != mySecondComm->recv_context)
	  printf("Error in MPI_Comm_dup of inter-communicators\n");
    if (rank == 1) {
      his_key = -1;
      printf("[%d] Before swap  key = %d, his_key = %d\n", rank,
             key, his_key);
      MPI_Sendrecv (&key,     1, MPI_INT, 0, 2,
                    &his_key, 1, MPI_INT, 0, 2, mySecondComm, &status);
      printf("[%d] After swap  key = %d, his_key = %d\n", rank,
             key, his_key);
    }
  }
  
  /* Finish up */
  MPI_Comm_free( &myComm );
  MPI_Comm_free( &myFirstComm );
  MPI_Comm_free( &mySecondComm );
  MPI_Finalize();
}
