/*
 *  $Id: chevent.c,v 1.4 1994/04/06 19:45:06 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char SCCSid[] = "%W% %G%";
#endif

#include "mpid.h"

/* 
   This file contains routines to see if the "device" wants to do anything
   (like receive some un-expected messages) 
 */
int MPID_NX_check_device( blocking )
int blocking;
{
if (blocking)
    MPID_NX_check_incoming( MPID_BLOCKING );
else 
    while (MPID_NX_check_incoming( MPID_NOTBLOCKING ) != -1);

/* Question: should we check on pending non-blocking operations here ?
   Probably not */
return MPI_SUCCESS;
}

/* Cancel a message.  This is complicated by the fact that we must
   be able to say that a message HAS been cancelled or completed successfully
   given ONLY the status.
 */
int MPID_NX_Cancel( r )
MPIR_COMMON *r;
{
/* If completed, do nothing */
/* Else:
   remove from queue
   mark as cancelled
   free any storage
 */
return MPI_SUCCESS;
}
