/*
 *  $Id: comm_rank.c,v 1.9 1994/04/07 08:55:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: comm_rank.c,v 1.9 1994/04/07 08:55:54 doss Exp $";
#endif /* lint */

#include <mpi.h>

/*@

MPI_Comm_rank - Determine the rank of the calling process in the communicator

Input Parameters:
. comm - communicator (handle) 
Output Parameter:
. rank - rank of the calling process in group of  comm  (integer) 

@*/
int MPI_Comm_rank ( comm, rank )
MPI_Comm  comm;
int      *rank;
{
  if (comm == MPI_COMM_NULL) {
    (*rank) = MPI_UNDEFINED;
    return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_COMM, 
					  "Error in MPI_COMM_RANK" );
  }
  else 
    (*rank) = comm->local_group->local_rank;

  return (MPI_SUCCESS);
}
