/*
 *  $Id: group_free.c,v 1.6 1994/04/07 08:55:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#include <mpi.h>

/*@

MPI_Group_free - Free a group

Input Parameter
. group - group (handle) 

@*/
int MPI_Group_free ( group )
MPI_Group *group;
{
  int errno = MPI_SUCCESS;

  /* Check for bad arguments */
  if ( ( (group    == (MPI_Group *)0) && (errno = MPI_ERR_ARG) ) ||
	   ( ((*group) == MPI_GROUP_NULL) && (errno = MPI_ERR_GROUP) ) )
	return MPIR_ERROR( MPI_COMM_NULL, errno,
					  "Error in MPI_GROUP_FREE" );

  /* Free group */
  if ( (*group)->ref_count <= 1 ) 
	MPIR_FreeGroup(*group);
  else 
	(*group)->ref_count--;
  (*group) = MPI_GROUP_NULL;

  return (errno);
}
