/*
 *  $Id: keyval_free.c,v 1.2 1994/04/07 21:08:43 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>
#include "mpisys.h"

/*@

MPI_Keyval_free - Free attribute key for communicator cache attribute

Input Parameter:
. keyval - Frees the integer key value (integer) 

@*/
int MPI_Keyval_free ( keyval )
int *keyval;
{
  MPIR_Attr_key *attr_key = (MPIR_Attr_key *)*keyval;

  if ( *keyval != 0 ) {
	if (attr_key->permanent) {
	  return MPIR_ERROR( MPI_COMM_WORLD, MPI_ERR_PERM_KEY, 
						"Can't free permanent attribute key" );
	}
	if (attr_key->ref_count <= 1) 
	  FREE ( (MPIR_Attr_key *)*keyval );
	else
	  attr_key->ref_count--;
	*keyval = MPI_KEYVAL_INVALID;
  }
  return (MPI_SUCCESS);
}
