#include "mpi.h"
#include "mpisys.h"

/*@
   MPI_Abort - Terminate MPI execution environment

Input Parameters:
. comm - communicator of tasks to abort 
. errorcode - error code to return to invoking environment 

@*/
int MPI_Abort( comm, errorcode )
MPI_Comm         comm;
int              errorcode;
{
MPID_ABORT( errorcode );

/* If for some reason we get here, force an abort */
abort( errorcode );

/* This keeps lint happy */
return MPI_ERR_UNKNOWN;
}
