/*
 *  $Id: errset.c,v 1.1 1994/03/29 21:46:28 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: errset.c,v 1.1 1994/03/29 21:46:28 gropp Exp $";
#endif

#include "mpi.h"

/*@
  MPI_Errhandler_set - Sets the error handler for a communicator

Input Parameters:
. comm - communicator to set the error handler for (handle) 
. errhandler - new MPI error handler for communicator (handle) 

@*/
int MPI_Errhandler_set( comm, errhandler )
MPI_Comm comm;
MPI_Errhandler errhandler;
{
if (comm == (MPI_Comm)0) {
    return MPIR_ERROR( comm, MPI_ERR_COMM_NULL, 
		       "Error in MPI_ERRHANDLER_SET" );
    }
else
    comm->error_handler = errhandler;
return MPI_SUCCESS;
}
