/*
 *  $Id: buffree.c,v 1.2 1994/03/30 22:58:41 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: buffree.c,v 1.2 1994/03/30 22:58:41 gropp Exp $";
#endif /* lint */

#include "mpi.h"

/*@
  MPI_Buffer_detach - Remove an existing buffer (for use in MPI_Bsend etc)

Output Parameters:
. buffer - initial buffer address (choice) 
. size - buffer size, in bytes (integer) 
@*/
int MPI_Buffer_detach( buffer, size )
void **buffer;
int  *size;
{
/* If we are using the buffer, we must first wait on all pending messages */

*buffer		 = MPIR_Buffer;
*size		 = MPIR_Buffer_size;

MPIR_Buffer	 = 0;
MPIR_Buffer_size = 0;
}

