/*
 *  $Id: get_elements.c,v 1.1 1994/04/18 15:47:26 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"


/*@
  MPI_Get_elements - Returns the number of basic elements
                     in a datatype
@*/
int MPI_Get_elements ( status, datatype, elements )
MPI_Status    status;
MPI_Datatype  datatype;
int          *elements;
{
  int count;

  /* Check for bad datatype */
  if (datatype == MPI_DATATYPE_NULL) 
	return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_TYPE,
					  "Error in MPI_GET_ELEMENTS" );
  
  /* Find the number of elements */
  MPI_Get_count (status, datatype, &count);
  if (count == MPI_UNDEFINED) {
	/* HACK ALERT -- the code in this if is not correct */
	/*               but for now ... */
	double cnt = 
	  (double) status.count_in_bytes / (double) datatype->size;
	(*elements) = (int) ( cnt * (double) datatype->elements );
  }
  else
	(*elements) = count * datatype->elements;

  return (MPI_SUCCESS);
}

