/*
 *  $Id: getcount.c,v 1.2 1994/04/15 18:59:44 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: getcount.c,v 1.2 1994/04/15 18:59:44 doss Exp $";
#endif /* lint */

#include "mpi.h"

/*@
  MPI_Get_count - Get the number of "top level" elements

Input Parameters:
. status - return status of receive operation (Status) 
. datatype - datatype of each receive buffer element (handle) 

Output Parameter:
. count - number of received elements (integer) 
  
@*/
int MPI_Get_count( status, datatype, count )
MPI_Status   status;
MPI_Datatype datatype;
int          *count;
{
  /* Check for bad datatype */
  if (datatype == MPI_DATATYPE_NULL) 
	return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_TYPE,
					  "Error in MPI_GET_COUNT" );

  /* Check for correct number of bytes */
  if ((status.count_in_bytes % (datatype->size)) != 0)
	(*count) = MPI_UNDEFINED;
  else
	(*count) = status.count_in_bytes / (datatype->size);

  return (MPI_SUCCESS);
}
