/*
 *  $Id
 *
 *  (C) 1994 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id$";
#endif /* lint */

#include "mpi.h"
#include "mpisys.h"

/* This initializes the fields of a request structure */

int MPIR_Recv_init( buf, count, datatype, source, tag, comm, request, 
		    nonblocking )
void          *buf;
int           count;
MPI_Datatype  datatype;
int           source;
int           tag;
MPI_Comm      comm;
MPI_Request   request;
int           nonblocking;
{
    request->type                 = MPIR_RECV;
    if (source == MPI_ANY_SOURCE)
	request->rhandle.source   = source;
    else
	request->rhandle.source   = comm->group->lrank_to_grank[source];
    request->rhandle.tag          = tag;
    request->rhandle.contextid    = comm->recv_context;
    request->rhandle.datatype     = datatype;
    request->rhandle.bufadd       = buf;
    request->rhandle.count        = count;
    request->rhandle.completed    = NO;
    MPID_alloc_recv_handle(&((request)->rhandle.dev_rhandle));
    MPID_set_recv_is_nonblocking( &((request)->rhandle.dev_rhandle), 
				 nonblocking );
}
