/*
 *  $Id: type_ub.c,v 1.1 1994/04/18 15:47:07 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"


/*@
    MPI_Type_ub - Return the number of "top-level" entries in 
                  the datatype
@*/
int MPI_Type_ub ( datatype, ub )
MPI_Datatype  datatype;
int          *ub;
{
  /* Check for bad datatype */
  if (datatype == MPI_DATATYPE_NULL) 
	return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_TYPE,
					  "Error in MPI_TYPE_UB" );

  /* Assign the ub and return */
  (*ub) = datatype->ub;
  return (MPI_SUCCESS);
}
